/********************************************************
 *
 * From Palm OS Programming Bible, Second Edition
 * 2002 Lonnon R. Foster.  All rights reserved.
 *
 * Modified to demo for ELE 101 at Princeton.
 *   March 2004
 *
 * *********************************************************/

#include <PalmOS.h>
#include "helloRsc.h"

static Boolean AppHandleEvent(EventType *event);
static Boolean MainFormHandleEvent(EventType *event);

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP,
                 UInt16 launchFlags)
{
    Err error = errNone;

    switch (cmd)
    {
        case sysAppLaunchCmdNormalLaunch: {
            EventType  event;

            FrmGotoForm(MainForm);

            do
            {
                EvtGetEvent(&event, evtWaitForever);
                if (!SysHandleEvent(&event)             &&
                    !MenuHandleEvent(0, &event, &error) &&
                    !AppHandleEvent(&event))
                        FrmDispatchEvent(&event);
            }
            while (event.eType != appStopEvent);
            
            FrmCloseAllForms();
            error = errNone;
            break;
        }
        default:
            break;
    }

    return error;
}

static Boolean AppHandleEvent(EventType *event)
{
    FormType  *form;
    UInt16    formID;
    Boolean   handled = false;
    

    if (event->eType == frmLoadEvent)
    {
        formID = event->data.frmLoad.formID;
        form = FrmInitForm(formID);
        FrmSetActiveForm(form);
        
        switch (formID)
        {
            case MainForm:
                FrmSetEventHandler(form,
                                   &MainFormHandleEvent);
                break;

            default:
                break;
        }
        handled = true;
    }

    return handled;
}

int x_position = 55, y_position = 60;

static Boolean MainFormHandleEvent(EventType *event)
{
    Boolean   handled = false;
    FormType  *form;

    switch (event->eType)
    {
        case frmOpenEvent:
            form = FrmGetActiveForm();
            FrmDrawForm(form);
            WinDrawChars( "hello, world", 12,
                          x_position, y_position );
            handled = true;
            break;
        case ctlSelectEvent:
            if(event->data.ctlEnter.controlID == AgainButton) {
                x_position = (x_position + 20) % 100;
                y_position = (y_position + 20) % 140;
                WinDrawChars( "hello again", 11,
                              x_position, y_position );
                handled = true;
            }
            break;
        default:
            break;
    }

    return handled;
}
