#include <PalmOS.h>
#include <StringMgr.h>

#include "resource.h"
#include "ele101.h"

void drawrandom();
Boolean checkmatch(Char* guessed_numbers, Char* num_str);

Boolean MainFormHandleEvent(EventPtr evt) {
    Boolean handled = false;
    FormPtr currentform;
    char tmp[100];

    switch (evt->eType) {
        case frmOpenEvent:
            /* Find which form object we're working on. */
            currentform = FrmGetActiveForm();
            FrmDrawForm(currentform);
            SysRandom(TimGetTicks());
            break;
        case ctlSelectEvent:
            if(evt->data.ctlEnter.controlID == drawbutton)
                drawrandom();
            handled = true;
            break;
        case penDownEvent:
            StrCopy(tmp, "                     ");
            WinDrawChars(tmp, StrLen(tmp), 110, 140);
            StrPrintF(tmp, "(%d, %d)", evt->screenX, evt->screenY);
            WinDrawChars(tmp, StrLen(tmp), 110, 140);
            break;
        default:
            break;
    }

    return handled;
}

void drawrandom() {
    /* Draws 5 random lottery numbers then prints them to the screen
       and tells the user how many matches were found. */
    Boolean seen[46] = { 0 };
    char num_str[4];
    FieldPtr field; 
    int i, match_count = 0;
    field = FrmGetObjectPtr(FrmGetActiveForm(),
              FrmGetObjectIndex(FrmGetActiveForm(), numberfield));

    for(i = 0; i < 5; i++) {
        int number_drawn;
        do {
            number_drawn = SysRandom(0) % 46;
        }
        while(seen[number_drawn] != 0);

        seen[number_drawn] = 1;
        StrIToA(num_str, number_drawn);
        WinDrawChars("     ", 5, 40 + i*15, 80);
        WinDrawChars(num_str, StrLen(num_str), 40 + i*15, 80);

        if (checkmatch(FldGetTextPtr(field), num_str))
            match_count += 1;
    }
    StrIToA(num_str, match_count);
    WinDrawChars(num_str, StrLen(num_str), 20, 100);
    WinDrawChars("of your numbers matched", 23, 30, 100);
}

Boolean checkmatch(Char* guessed_numbers, Char* num_str) {
    /* Takes a list of lottery numbers and tells if the single
     * number represented by num_str is among the list. Some care
     * must be taken to ensure the number is by itself (e.g.
     * don't count "27" as having an instance of "2".) */
    Char *match;
    match = guessed_numbers;
    while (match != NULL) {
        match = StrStr(match, num_str);
        if (match != NULL) {
            if ( (match == guessed_numbers || match[-1] == ' ') &&
                 (StrCompare(match, num_str) == 0 ||
                  match[StrLen(num_str)] == ' '))
                return true;
            match += 1; /* move one space over */
        }
    }
    return false;
}

UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    if(cmd == sysAppLaunchCmdNormalLaunch) {
        UInt16 errorcode;
        errorcode = StartApplication();
        if (errorcode != 0)
            return errorcode;
        EventLoop();
        StopApplication();
        return 0;
    } 
    else
        return sysErrParamErr;
}
